#!/usr/bin/perl
## This script merge the orthology information files (e.g., Human vs Chimp) into one file.

###  perl 010_orthoTableMaker.pl <orthologyTable> <addingIDs>

## 1st command
##   perl 010_orthoTableMaker.pl 010_out_orthoFile.txt mart_export_HumanTEST.txt
## 2nd command
##   perl 010_orthoTableMaker.pl 010_out_orthoFile_1.txt mart_export_ChimpTEST.txt
## 3id command
##   perl 010_orthoTableMaker.pl 010_out_orthoFile_1_1.txt mart_export_DogTEST.txt


use strict;
use warnings;

my $orthoFile = $ARGV[0];
my $addFile   = $ARGV[1];

## Making outfile name.
my $outfile   = $orthoFile;
$outfile   =~ s/\.txt//;
$outfile   = $outfile."_1.txt";



## Main program
my @orthoLines = ();
if(-e "$orthoFile"){  ### Second time and later
  print "$orthoFile was FOUND.\n\n";

  my $refOrthoLines = &readFile($orthoFile);
  my @orthoLines = @$refOrthoLines;
  my $refAddLines = &readFile($addFile);
  my @addLines = @$refAddLines;

  open(OUT,">$outfile");
  my $count = 0;
  foreach my $orthoLine (@orthoLines) {
    $count++;
    chomp($orthoLine);

    ## Pick up the human ID
    my $humanID = $orthoLine;
    $humanID =~ s/\t.*$//g;

    if(my $addLine = join("",(grep/$humanID/,@addLines))){
      chomp($addLine);
      if($addLine =~ /\tortholog_one2one/){
        print "$count. FIND:$humanID\n";

        ## Pick up humanInAdd_ID and add_ID from $addLine

        my $humanInAdd_ID = $addLine;
        my $addID         = $addLine;
        $humanInAdd_ID    =~ s/\t.*$//g;
        $addID =~ s/^.*?\t//g;
        $addID =~ s/\t.*?$//g;
        print OUT "$orthoLine\t$addID\n";

      } else {
        print "$count. NOT FIND:$humanID\n";
        print OUT "$orthoLine\tNONE\n";
      }

    } else {
      print "$count. NOT FIND:$humanID\n";
      print OUT "$orthoLine\tNONE\n";
    }

  }
  close OUT;

} 
else { ### First time
  print "\n$orthoFile was Not Found. Newly maden.\n\n";
  my $refAddLines = &readFile($addFile);
  my @addLines = @$refAddLines;
  my $count = 0;
  open(OUT,">$outfile");
  foreach my $line (@$refAddLines){
    $count++;
    print "$count. $line\n";
    print OUT "$line\n";
  }
  close OUT;
  print "Make sure the last number matches to the number of lines in your infile.\n\n";
}


#######
sub readFile {
  my ($fileSR) = @_;
  my @linesSR = ();
  
  open(ADD, "$fileSR") or die "Failed to open $fileSR. Stopped.\n\n";
  while(my $line = <ADD>){
    unless($line =~ /^Ensembl/){
      chomp($line);
      #print "$line\n";
      push(@linesSR, $line);
    }
  }
  close ADD;
  return \@linesSR;
}