#!/usr/bin/perl

###  perl 040_autoMafft.pl <aaFileDir>

## Example
#  perl 040_autoMafft.pl 020_out_multiAAFiles


use strict;
use warnings;

my $aaFileDir = $ARGV[0];
my $outDir    = "040_out_aligneAAfileDir";



#### read aa dir
opendir(DIR, "$aaFileDir") or die "Failed to open $aaFileDir. Stopped.\n";
my @aaDirs = readdir(DIR);
close DIR;


### 
unless(-d "$outDir"){
  print "\n";
  print "$outDir was made.\n";
  print "\n";
  system("mkdir $outDir");
}

my $countFile = 0;
foreach my $aaFile (@aaDirs) {
  next if $aaFile =~ /^\./;
  $countFile++;
  print "$countFile. $aaFile.\n";
  system("mafft --auto $aaFileDir/$aaFile > $outDir/$aaFile");  #### <= Make sure the directory where the MAFFT installed.
}


exit;