#!/usr/bin/perl

###  perl  <alignedAAfileDir> <cDNAfileDir>

## Example
#  perl 050_autoPAL2NAL.pl 040_out_aligneAAfileDir 030_out_multiCDNAFiles



use strict;
use warnings;

my $aaFileDir   = $ARGV[0];
my $cdnaFileDir = $ARGV[1];
my $outDir    = "050_out_aligneCDNAfileDir";


### Make sure the existence of the directories.
unless(-d "$aaFileDir"){
  print "NOT FOUND: $aaFileDir. Stopped.\n";
  exit;
}
unless(-d "$cdnaFileDir"){
  print "NOT FOUND: $cdnaFileDir. Stopped.\n";
  exit;
}

#### read aa dir
opendir(DIR, "$aaFileDir") or die "Failed to open $aaFileDir. Stopped.\n";
my @aaDirs = readdir(DIR);
close DIR;


### 
unless(-d "$outDir"){
  print "\n";
  print "$outDir was made.\n";
  print "\n";
  system("mkdir $outDir");
}

my $countFile = 0;
foreach my $aaFile (@aaDirs) {
  next if $aaFile =~ /^\./;
  $countFile++;
  print "$countFile. $aaFile.\n";
  system("perl 050_pal2nal.pl $aaFileDir/$aaFile $cdnaFileDir/$aaFile -output fasta > $outDir/$aaFile");
  print "\n\n\n\n";
}


exit;